package com.employee.EmployeeManagement.Controller;

import com.employee.EmployeeManagement.Model.Employee;
import com.employee.EmployeeManagement.Repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;
import java.util.Optional;

@Controller
public class EmployeeController {
    @Autowired
    EmployeeRepository employeeRepository;

    @GetMapping("/")
    public String getEmployee(Model model)
    {
        List<Employee> empList = employeeRepository.findAll();
        for (int i = 0; i < empList.size(); i++) {
            System.out.println(empList.get(i));
        }
        System.out.println();
        model.addAttribute("employees",empList);
        return "home";
    }

    @GetMapping("/new")
    public String homeEmployee( Model model)
    {
        model.addAttribute("pageTitle","Enter New Employee Details");
        model.addAttribute("givenEmpid","");
        model.addAttribute("givenFirstName","");
        model.addAttribute("givenLastName","");
        model.addAttribute("givenEmail","");
        model.addAttribute("employee",new Employee());
        model.addAttribute("givenAction","/employees");
        return "entry";
    }

    @PostMapping("/employees")
    //public String createEmployee(@RequestParam String firstname,@RequestParam String lastname,@RequestParam String email) {
    public String createEmployee(@ModelAttribute Employee employee) {
        //Employee employee = new Employee(firstname,lastname,email);
        employeeRepository.save(employee);
        return "redirect:/";
    }
    @GetMapping("/employee/{id}")
    public String editEmployee( @PathVariable(value = "id") Long empId ,Model model)
    {
        Optional<Employee> optional = employeeRepository.findById(empId);
        Employee employee = optional.orElse(new Employee());
        model.addAttribute("pageTitle","Edit Employee Details");
        model.addAttribute("givenEmpid",employee.getEmpId());
        model.addAttribute("givenFirstName",employee.getEmpFirstName());
        model.addAttribute("givenLastName",employee.getEmpLastName());
        model.addAttribute("givenEmail",employee.getEmpEmail());
        model.addAttribute("employee",employee);
        model.addAttribute("givenAction","/employee/"+empId);
        return "entry";
    }

    @PostMapping("/employee/{id}")
    public String updateEmployee(@PathVariable(value = "id") Long empId,@ModelAttribute Employee employee)
    {
        Optional<Employee> optional = employeeRepository.findById(empId);
        Employee employee1 = optional.orElse(new Employee());
        employee1.setEmpFirstName(employee.getEmpFirstName());
        employee1.setEmpLastName(employee.getEmpLastName());
        employee1.setEmpEmail(employee.getEmpEmail());
        employeeRepository.save(employee1);
        return "redirect:/";
    }

    @GetMapping("/employee/delete/{id}")
    public String deleteEntry(@PathVariable(value = "id") Long empId) {
        employeeRepository.deleteById(empId);
        return "redirect:/";

    }

}
